/*  matrix.h
 *
 *  Copyright (C) 2012, Institute of Enzymology,
 *  Daniel Kozma,  kozmad at enzim dot hu

 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __matrix_h_
#define __matrix_h_

#ifdef __cplusplus
extern "C" {
#endif

int** createIntMatrix(int nRows, int nCols);
float** createFloatMatrix(int nRows, int nCols);
double** createDoubleMatrix(int nRows, int nCols);
char** createCharMatrix(int nRows, int nCols);

int maxIntInMatrix(int **matrix, int nRows, int nCols);
float maxFloatInMatrix(float **matrix, int nRows, int nCols);
double maxDoubleInMatrix(double **matrix, int nRows, int nCols);

int minIntInMatrix(int **matrix, int nRows, int nCols);
float minFloatInMatrix(float **matrix, int nRows, int nCols);
double minDoubleInMatrix(double **matrix, int nRows, int nCols);

void printIntMatrix(int **matrix, int nRows, int nCols);
void printFloatMatrix(float **matrix, int nRows, int nCols);
void printDoubleMatrix(double **matrix, int nRows, int nCols);
void printCharMatrix(char **matrix, int nRows, int nCols);

void freeIntMatrix(int **matrix, int nRows);
void freeFloatMatrix(float **matrix, int nRows);
void freeDoubleMatrix(double **matrix, int nRows);
void freeCharMatrix(char **matrix, int nRows);


#ifdef __cplusplus
}
#endif

#endif /* matrix.h */
