/*  nonstdio.h
 *
 *  Copyright (C) 2012, Institute of Enzymology,
 *  Daniel Kozma,  kozmad at enzim dot hu

 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __nonstdio_h_
#define __nonstdio_h_

#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>


#define ASCII 32
#ifndef BOOLEAN
#define BOOLEAN	
typedef unsigned short int boolean;
#endif

char *  readFileContent(char * filename);
char ** readLinesFromFile(char * filename);
void    freeLines(char **lines);
char ** readLinesFromStream(FILE *f);
char *  readContentFromStream(FILE *f);
char ** getSequences(char ** nameseq);
char ** getNamesSequences(char ** fastaContent);
char *  removeWhitespaces(char * str);
char *  substr(char * str, int p, int l);
char *  strdel(char * str, int p, int l);
char *  strins(char * str, char * ins, int p);
char *  strrep(char * str, char * from, char * to);
char ** strspl(char * str, char * delim);
char *  strjoin(char ** splstr, char * delim);

#ifdef __cplusplus
}
#endif

#endif /*nonstdio.h*/
